#!/bin/bash
#########################################################
#
# Script to keep your dynIP up-to-date
#
### Should NOT be called more than once every minute!!!!!
#
# Assumes both "curl" and "dig" are available in the path
# 
#########################################################

set -o errexit
set -o pipefail

if [ ${#1} -eq 0 ] || [ ${#2} -eq 0 ] ; then
	echo "\$1 = Dyn IP address"
	echo "\$2 = Dyn IP password"
	echo "\$3 = IPv6 if you also want to update an IPv6 address"
else
	set -o nounset 

	ADDRESS="${1}"
	PASSWORD="${2}"
	IPV6="${3-ipv4only}"
	
	CURRENTIP4=$(curl -4 http://www.bnamed.net/dyn/ip.asp | grep Current | awk '{print $4}')
	echo "Current IPv4: " $CURRENTIP4
	OLDIP4=$(dig +short -t A $ADDRESS)
	echo "Old IPv4: " $OLDIP4
	
	URL=""
	
	if [[ "$IPV6" = "IPv6" ]]; then
		CURRENTIP6=$(curl -6 http://ip6.me/api/ | grep IPv6 | awk -F ',' '{print $2}')
		echo "Current IPv6: " $CURRENTIP6
		OLDIP6=$(dig +short -t AAAA $ADDRESS)
		echo "Old IPv6: " $OLDIP6
		
		if [[ "$CURRENTIP4" != "$OLDIP4" ]] || [[ "$CURRENTIP6" != "$OLDIP6" ]]; then
			URL="https://www.bnamed.net/dyn/dyn.asp?ipv4=$CURRENTIP4&ipv6=$CURRENTIP6"
		fi
	else
		if [[ "$CURRENTIP4" != "$OLDIP4" ]]; then
			URL="https://www.bnamed.net/dyn/dyn.asp?ipv4=$CURRENTIP4"
		fi
	fi


	if [[ "$URL" != "" ]]; then
		echo "IP needs to be changed"
		RESPONSE=$(curl --basic --user $ADDRESS:$PASSWORD "$URL")
		if [[ "$RESPONSE" = good ]]
		then
			echo "IP changed: $RESPONSE"
		else
			echo "IP change failed: $RESPONSE"
		fi
	else
		echo "No change, no action"
	fi
fi
